com.fasterxml.jackson.databind.deser

## Class BeanDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
    - - com.fasterxml.jackson.databind.deser.BeanDeserializerBase
      - - com.fasterxml.jackson.databind.deser.BeanDeserializer

All Implemented Interfaces:
  ContextualDeserializer, NullValueProvider, ResolvableDeserializer, ValueInstantiator.Gettable, Serializable

Direct Known Subclasses:
  ThrowableDeserializer

    public class BeanDeserializer
    extends BeanDeserializerBase
    implements Serializable

Deserializer class that can deserialize instances of arbitrary bean objects, usually from JSON Object structs,

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Exception` `_nullFromCreator` Lazily constructed exception used as root cause if reporting problem with creator method that returns `null` (which is not allowed)

### Fields inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

`_anySetter, _arrayDelegateDeserializer, _backRefs, _beanProperties, _beanType, _delegateDeserializer, _externalTypeIdHandler, _ignorableProps, _ignoreAllUnknown, _injectables, _needViewProcesing, _nonStandardCreation, _objectIdReader, _propertyBasedCreator, _serializationShape, _subDeserializers, _unwrappedPropertyHandler, _valueInstantiator, _vanillaProcessing, TEMP_PROPERTY_NAME`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`protected` `BeanDeserializer(BeanDeserializerBase src)` Copy-constructor that can be used by sub-classes to allow copy-on-write style copying of settings of an existing instance.
`` `BeanDeserializer(BeanDeserializerBase src, BeanPropertyMap props)`
`protected` `BeanDeserializer(BeanDeserializerBase src, boolean ignoreAllUnknown)`
`protected` `BeanDeserializer(BeanDeserializerBase src, NameTransformer unwrapper)`
`` `BeanDeserializer(BeanDeserializerBase src, ObjectIdReader oir)`
`` `BeanDeserializer(BeanDeserializerBase src, Set<String> ignorableProps)`
`` `BeanDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, BeanPropertyMap properties, Map<String,SettableBeanProperty> backRefs, HashSet<String> ignorableProps, boolean ignoreAllUnknown, boolean hasViews)` Constructor used by `BeanDeserializerBuilder`.

### Method Summary

Methods
`protected Exception` `_creatorReturnedNullException()` Helper method for getting a lazily construct exception to be reported to `DeserializationContext.handleInstantiationProblem(Class, Object, Throwable)`.
`protected Object` `_deserializeOther(JsonParser p, DeserializationContext ctxt, JsonToken t)`
`protected Object` `_deserializeUsingPropertyBased(JsonParser p, DeserializationContext ctxt)` Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters.
`protected Object` `_deserializeWithErrorWrapping(JsonParser p, DeserializationContext ctxt, SettableBeanProperty prop)`
`protected Object` `_missingToken(JsonParser p, DeserializationContext ctxt)` Deprecated.
`protected BeanDeserializerBase` `asArrayDeserializer()` Fluent factory for creating a variant that can handle POJO output as a JSON Array.
`Object` `deserialize(JsonParser p, DeserializationContext ctxt)` Main deserialization method for bean-based objects (POJOs).
`Object` `deserialize(JsonParser p, DeserializationContext ctxt, Object bean)` Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
`protected Object` `deserializeFromNull(JsonParser p, DeserializationContext ctxt)` Helper method called for rare case of pointing to `JsonToken.VALUE_NULL` token.
`Object` `deserializeFromObject(JsonParser p, DeserializationContext ctxt)` General version used when handling needs more advanced features.
`protected Object` `deserializeUsingPropertyBasedWithExternalTypeId(JsonParser p, DeserializationContext ctxt)`
`protected Object` `deserializeUsingPropertyBasedWithUnwrapped(JsonParser p, DeserializationContext ctxt)`
`protected Object` `deserializeWithExternalTypeId(JsonParser p, DeserializationContext ctxt)`
`protected Object` `deserializeWithExternalTypeId(JsonParser p, DeserializationContext ctxt, Object bean)`
`protected Object` `deserializeWithUnwrapped(JsonParser p, DeserializationContext ctxt)` Method called when there are declared "unwrapped" properties which need special handling
`protected Object` `deserializeWithUnwrapped(JsonParser p, DeserializationContext ctxt, Object bean)`
`protected Object` `deserializeWithView(JsonParser p, DeserializationContext ctxt, Object bean, Class<?> activeView)`
`JsonDeserializer<Object>` `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
`BeanDeserializerBase` `withBeanProperties(BeanPropertyMap props)` Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
`BeanDeserializer` `withIgnorableProperties(Set<String> ignorableProps)`
`BeanDeserializer` `withObjectIdReader(ObjectIdReader oir)`

### Methods inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

`_convertObjectId, _findSubclassDeserializer, _handleTypedObjectId, _resolvedObjectIdProperty, _resolveInnerClassValuedProperty, _resolveManagedReferenceProperty, _resolveMergeAndNullSettings, _resolveUnwrappedProperty, createContextual, creatorProperties, deserializeFromArray, deserializeFromBoolean, deserializeFromDouble, deserializeFromEmbedded, deserializeFromNumber, deserializeFromObjectId, deserializeFromObjectUsingNonDefault, deserializeFromString, deserializeWithObjectId, deserializeWithType, findBackReference, findConvertingDeserializer, findProperty, findProperty, findProperty, getBeanClass, getEmptyAccessPattern, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getObjectIdReader, getPropertyCount, getValueInstantiator, getValueType, handledType, handleIgnoredProperty, handlePolymorphic, handleUnknownProperties, handleUnknownProperty, handleUnknownVanilla, hasProperty, hasViews, injectValues, isCachable, properties, replaceProperty, resolve, supportsUpdate, wrapAndThrow, wrapInstantiationProblem`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBooleanFromInt, _parseBooleanPrimitive, _parseDate, _parseDate, _parseDoublePrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _shortOverflow, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, handleMissingEndArrayForSingle, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`getDelegatee, getEmptyValue, getNullValue, getNullValue, replaceDelegatee`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _nullFromCreator

    protected transient Exception _nullFromCreator

Lazily constructed exception used as root cause if reporting problem with creator method that returns `null` (which is not allowed)

Since:
  2.8

### Constructor Detail

#### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBuilder builder,
                    BeanDescription beanDesc,
                    BeanPropertyMap properties,
                    Map<String,SettableBeanProperty> backRefs,
                    HashSet<String> ignorableProps,
                    boolean ignoreAllUnknown,
                    boolean hasViews)

Constructor used by `BeanDeserializerBuilder`.

#### BeanDeserializer

    protected BeanDeserializer(BeanDeserializerBase src)

Copy-constructor that can be used by sub-classes to allow copy-on-write style copying of settings of an existing instance.

#### BeanDeserializer

    protected BeanDeserializer(BeanDeserializerBase src,
                    boolean ignoreAllUnknown)

#### BeanDeserializer

    protected BeanDeserializer(BeanDeserializerBase src,
                    NameTransformer unwrapper)

#### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBase src,
                    ObjectIdReader oir)

#### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBase src,
                    Set<String> ignorableProps)

#### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBase src,
                    BeanPropertyMap props)

### Method Detail

#### unwrappingDeserializer

    public JsonDeserializer<Object> unwrappingDeserializer(NameTransformer unwrapper)

Description copied from class: `JsonDeserializer`
Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

Default implementation just returns 'this' indicating that no unwrapped variant exists

Specified by:
  `unwrappingDeserializer` in class `BeanDeserializerBase`

#### withObjectIdReader

    public BeanDeserializer withObjectIdReader(ObjectIdReader oir)

Specified by:
  `withObjectIdReader` in class `BeanDeserializerBase`

#### withIgnorableProperties

    public BeanDeserializer withIgnorableProperties(Set<String> ignorableProps)

Specified by:
  `withIgnorableProperties` in class `BeanDeserializerBase`

#### withBeanProperties

    public BeanDeserializerBase withBeanProperties(BeanPropertyMap props)

Description copied from class: `BeanDeserializerBase`
Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.

Overrides:
  `withBeanProperties` in class `BeanDeserializerBase`

#### asArrayDeserializer

    protected BeanDeserializerBase asArrayDeserializer()

Description copied from class: `BeanDeserializerBase`
Fluent factory for creating a variant that can handle POJO output as a JSON Array. Implementations may ignore this request if no such input is possible.

Specified by:
  `asArrayDeserializer` in class `BeanDeserializerBase`

#### deserialize

    public Object deserialize(JsonParser p,
                     DeserializationContext ctxt)
                       throws IOException

Main deserialization method for bean-based objects (POJOs).

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### _deserializeOther

    protected final Object _deserializeOther(JsonParser p,
                           DeserializationContext ctxt,
                           JsonToken t)
                                      throws IOException

Throws:
  `IOException`

#### _missingToken

    @Deprecated
    protected Object _missingToken(JsonParser p,
                                  DeserializationContext ctxt)
                            throws IOException

Deprecated.

Throws:
  `IOException`

#### deserialize

    public Object deserialize(JsonParser p,
                     DeserializationContext ctxt,
                     Object bean)
                       throws IOException

Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.

Overrides:
  `deserialize` in class `JsonDeserializer<Object>`
Throws:
  `IOException`

#### deserializeFromObject

    public Object deserializeFromObject(JsonParser p,
                               DeserializationContext ctxt)
                                 throws IOException

General version used when handling needs more advanced features.

Specified by:
  `deserializeFromObject` in class `BeanDeserializerBase`
Throws:
  `IOException`

#### _deserializeUsingPropertyBased

    protected Object _deserializeUsingPropertyBased(JsonParser p,
                                        DeserializationContext ctxt)
                                             throws IOException

Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters. The trick is that values for creator method need to be buffered, first; and due to non-guaranteed ordering possibly some other properties as well.

Specified by:
  `_deserializeUsingPropertyBased` in class `BeanDeserializerBase`
Throws:
  `IOException`

#### _deserializeWithErrorWrapping

    protected final Object _deserializeWithErrorWrapping(JsonParser p,
                                       DeserializationContext ctxt,
                                       SettableBeanProperty prop)
                                                  throws IOException

Throws:
  `IOException`

#### deserializeFromNull

    protected Object deserializeFromNull(JsonParser p,
                             DeserializationContext ctxt)
                                  throws IOException

Helper method called for rare case of pointing to `JsonToken.VALUE_NULL` token. While this is most often an erroneous condition, there is one specific case with XML handling where polymorphic type with no properties is exposed as such, and should be handled same as empty Object.

Throws:
  `IOException`
Since:
  2.7

#### deserializeWithView

    protected final Object deserializeWithView(JsonParser p,
                             DeserializationContext ctxt,
                             Object bean,
                             Class<?> activeView)
                                        throws IOException

Throws:
  `IOException`

#### deserializeWithUnwrapped

    protected Object deserializeWithUnwrapped(JsonParser p,
                                  DeserializationContext ctxt)
                                       throws IOException

Method called when there are declared "unwrapped" properties which need special handling

Throws:
  `IOException`

#### deserializeWithUnwrapped

    protected Object deserializeWithUnwrapped(JsonParser p,
                                  DeserializationContext ctxt,
                                  Object bean)
                                       throws IOException

Throws:
  `IOException`

#### deserializeUsingPropertyBasedWithUnwrapped

    protected Object deserializeUsingPropertyBasedWithUnwrapped(JsonParser p,
                                                    DeserializationContext ctxt)
                                                         throws IOException

Throws:
  `IOException`

#### deserializeWithExternalTypeId

    protected Object deserializeWithExternalTypeId(JsonParser p,
                                       DeserializationContext ctxt)
                                            throws IOException

Throws:
  `IOException`

#### deserializeWithExternalTypeId

    protected Object deserializeWithExternalTypeId(JsonParser p,
                                       DeserializationContext ctxt,
                                       Object bean)
                                            throws IOException

Throws:
  `IOException`

#### deserializeUsingPropertyBasedWithExternalTypeId

    protected Object deserializeUsingPropertyBasedWithExternalTypeId(JsonParser p,
                                                         DeserializationContext ctxt)
                                                              throws IOException

Throws:
  `IOException`

#### _creatorReturnedNullException

    protected Exception _creatorReturnedNullException()

Helper method for getting a lazily construct exception to be reported to `DeserializationContext.handleInstantiationProblem(Class, Object, Throwable)`.

Since:
  2.8